#!/usr/bin/python
import MySQLdb as mdb
import time

#
# Get all rows from MySQL (about 22 MB worth of data)
#
db = mdb.connect(host='localhost', user='MYSQL_USERNAME', passwd='MYSQL_PASSWORD', db='MYSQL_DATABASE')
c = db.cursor()
c.execute("""SELECT * FROM stories ORDER BY snapshot_epoch ASC""")
rows = c.fetchall()
db.close()

last_seen = {}

for row in rows:
  pos = row[0]
  href = row[1]
  submit_ep = int(row[4])
  snap_ep = int(row[5])
  score = row[6]
  submitter = row[7]

  if href in last_seen:
    (last_snapshot, last_pos, last_score, last_snap, last_submit) = last_seen[href]
    pos_delta = pos - last_pos
    votes_delta = score - last_score
    submit_delta = submit_ep - last_submit
    if votes_delta < 0:
      # This is the dirty trick: delete the submission and then re-submit it, which 
      # causes votes_since to be negative. Since Hacker News does not have downvoting on
      # submissions, we know that this is some funny business.
      print "===="
      print href, submitter, last_score, time.asctime(time.localtime(last_snapshot)), time.asctime(time.localtime(last_submit))
      print href, submitter, score, time.asctime(time.localtime(snap_ep)), time.asctime(time.localtime(submit_ep)), '('+str(submit_delta)+')'
      print "===="

  last_seen[href] = (snap_ep, pos, score, snap_ep, submit_ep)
